public class GetActiveEquipmentFlow 
{
    public static Boolean isFirstTime = true;
    
    @AuraEnabled
    public static List<EquipData> getActiveEquips(String strEquipIds,String strHEIds,String strSBIds)
    {
        List<EquipData> allEquipDataList=new List<EquipData>();
        List<Id> equipIds=new List<Id>();
        List<Id> heIds=new List<Id>();
        List<Id> sbIds=new List<Id>();
        
        equipIds=(List<Id>)JSON.deserialize(strEquipIds, List<Id>.class);
        heIds=(List<Id>)JSON.deserialize(strHEIds, List<Id>.class);
        sbIds=(List<Id>)JSON.deserialize(strSBIds, List<Id>.class);
        
        if(equipIds!=null && equipIds.size()>0){getActiveTEEquips(equipIds,allEquipDataList);}
        if(heIds!=null && heIds.size()>0){getActiveHEEquips(heIds,allEquipDataList);}
        if(sbIds!=null && sbIds.size()>0){getActiveSBEquips(sbIds,allEquipDataList);}
        
        return allEquipDataList;
    }
    @AuraEnabled
    public static List<EquipData> getActiveTEEquips(List<Id> equipIds,List<EquipData> equipDataList)
    {
        List<Tenant_Equipment__c> equipList=[select Id,Where_it_s_active_elsewhere__c,Name,Action__c,Case__c,Equip_Lookup_info__c,
                                             Is_active_elsewhere__c,IsOverrideCaseCreated__c,Amdocs_Tenant_ID__c,Customer_First_Name__c,Customer_Last_Name__c,
                                             Phone_Number__c,Address__c,Unit__c from Tenant_Equipment__c where id in:equipIds];
        system.debug('Mahim-equipList: '+equipList);
        
        //Milestone: MS-000022 - Mahim - Start
        //Getting the TenantID from the active TenantEquipment record
        List<string> receiverNumbers = new List<string>();
        for(Tenant_Equipment__c TE: equipList){
            receiverNumbers.add(string.valueof(TE.Name));
        }
        system.debug('Mahim-receiverNumbers: '+receiverNumbers);
        List<Tenant_Equipment__c> activeEquipList=[select Id,Name,Amdocs_Tenant_ID__c from Tenant_Equipment__c 
                                                   where Name in :receiverNumbers and Action__c='Active'];
        system.debug('Mahim-activeEquipList: '+activeEquipList);
        //Milestone: MS-000022 - Mahim - End
        
        
        Boolean hasOwnDupe=false;
        Boolean hasOtherDupe=false;
        Boolean hasAdded=false;
        
        for(Tenant_Equipment__c anE:equipList)
        {
            EquipData aData=populateEquipData(anE.Id,anE.Equip_Lookup_info__c,
                                              anE.Name,anE.Is_active_elsewhere__c,anE.Where_it_s_active_elsewhere__c);
            
            aData.isTE=true;
            
            if(anE.Case__c!=null){aData.isOther=true;hasOtherDupe=true;}
            if(anE.Case__c!=null)aData.caseDetails=anE.Case__c;
            
            if(anE.Is_active_elsewhere__c && anE.Case__c==null)hasOwnDupe=true;
            
            //MS-001664 - commenting out the below logic - 11May20
            //if(!anE.Is_active_elsewhere__c && anE.Action__c=='Active'){hasOwnDupe=true;aData.isActiveElsewhere=true;}
                        
            if(!anE.Is_active_elsewhere__c)hasAdded=true;
            
            //if(anE.Is_active_elsewhere__c){
            String CustomerName;
            if(anE.Customer_First_Name__c != null && anE.Customer_Last_Name__c == null)
                CustomerName = anE.Customer_First_Name__c;
            if (anE.Customer_First_Name__c == null && anE.Customer_Last_Name__c != null)
                CustomerName = anE.Customer_Last_Name__c;
            if (anE.Customer_First_Name__c != null && anE.Customer_Last_Name__c != null)
                CustomerName = anE.Customer_First_Name__c + ' ' + anE.Customer_Last_Name__c;
            
            if(anE.Amdocs_Tenant_ID__c != '' && anE.Amdocs_Tenant_ID__c != null)
                aData.equipName = aData.equipName+' | '+anE.Amdocs_Tenant_ID__c;
            if(CustomerName != null)
                aData.equipName = aData.equipName +' | '+CustomerName;
            if(anE.Phone_Number__c != '' && anE.Phone_Number__c != null)
                aData.equipName = aData.equipName+' | '+anE.Phone_Number__c;
            if(anE.Address__c != '' && anE.Address__c != null)
                aData.equipName = aData.equipName+' | '+anE.Address__c;
            if(anE.Unit__c != '' && anE.Unit__c != null)
                aData.equipName = aData.equipName+' | '+anE.Unit__c;
            //}
            //Milestone: MS-000022 - Mahim - Start
            for(Tenant_Equipment__c TE: activeEquipList){
                if(TE.Name == anE.Name){                    
                    aData.TenantID = TE.Amdocs_Tenant_ID__c;
                }
            }
            //Milestone: MS-000022 - Mahim - End
            
            equipDataList.add(aData);
            system.debug('equipDataList - '+ equipDataList);
        }
        
        if(equipDataList.size()>0)
        {
            equipDataList[0].hasOwnActiveElsewhere=hasOwnDupe;
            equipDataList[0].hasOtherActiveElsewhere=hasOtherDupe;
            equipDataList[0].hasAddedEquip=hasAdded;
        }
        
        return equipDataList;
    }
    @AuraEnabled
    public static List<EquipData> getActiveHEEquips(List<Id> equipIds,List<EquipData> equipDataList)
    {
        List<Equipment__c> equipList=[select Id,Where_it_s_active_elsewhere__c,Name,Action__c,CaseNumber__c,Equip_Lookup_info__c,
                                      Is_active_elsewhere__c from Equipment__c where id in:equipIds];
        
        //Milestone: MS-000022 - Mahim - Start
        //Getting the ServiceID from the active HeadEndtEquipment record
        List<string> receiverNumbers = new List<string>();
        for(Equipment__c HE: equipList){
            receiverNumbers.add(string.valueof(HE.Name));
        }
        system.debug('Mahim-receiverNumbers: '+receiverNumbers);
        List<Equipment__c> activeEquipList=[select Id,Name,Opportunity__r.AmDocs_ServiceID__c from Equipment__c 
                                            where Name in :receiverNumbers and Action__c='Active'];
        system.debug('Mahim-activeEquipList: '+activeEquipList);
        //Milestone: MS-000022 - Mahim - End
        
        Boolean hasOwnDupe=false;
        Boolean hasOtherDupe=false;
        Boolean hasAdded=false;
        
        for(Equipment__c anE:equipList)
        {
            EquipData aData=populateEquipData(anE.Id,anE.Equip_Lookup_info__c,
                                              anE.Name,anE.Is_active_elsewhere__c,anE.Where_it_s_active_elsewhere__c); 
            
            aData.isHE=true;
            
            if(anE.CaseNumber__c!=null){aData.isOther=true;hasOtherDupe=true;}
            if(anE.CaseNumber__c!=null)aData.caseDetails=anE.CaseNumber__c;
            
            if(anE.Is_active_elsewhere__c && anE.CaseNumber__c==null)hasOwnDupe=true;
            if(!anE.Is_active_elsewhere__c && anE.Action__c=='Active'){hasOwnDupe=true;aData.isActiveElsewhere=true;}
            if(!anE.Is_active_elsewhere__c)hasAdded=true;
            
            //Milestone: MS-000022 - Mahim - Start
            for(Equipment__c HE: activeEquipList){if(HE.Name == anE.Name){aData.ServiceID = HE.Opportunity__r.AmDocs_ServiceID__c;}}
            //Milestone: MS-000022 - Mahim - End
            
            equipDataList.add(aData);
        }
        
        if(equipDataList.size()>0)
        {
            equipDataList[0].hasOwnActiveElsewhere=hasOwnDupe;
            equipDataList[0].hasOtherActiveElsewhere=hasOtherDupe;
            equipDataList[0].hasAddedEquip=hasAdded;
        }
        
        return equipDataList;
    }
    @AuraEnabled
    public static List<EquipData> getActiveSBEquips(List<Id> equipIds,List<EquipData> equipDataList)
    {
        //Milestone: MS-001258 - Mahim - Added CAID__c in below query
        List<Smartbox__c> equipList=[select Id,Where_it_s_active_elsewhere__c,Name,Action__c,Case__c,Equip_Lookup_info__c,
                                     Is_active_elsewhere__c,CAID__c from Smartbox__c where id in:equipIds]; 
        
        //Milestone: MS-000022 - Mahim - Start
        //Getting the ServiceID from the active SmartBoxEquipment record
        List<string> receiverNumbers = new List<string>();
        for(Smartbox__c SB: equipList){
            receiverNumbers.add(string.valueof(SB.CAID__c));
        }
        system.debug('Mahim-receiverNumbers: '+receiverNumbers);
        List<Smartbox__c> activeEquipList=[select Id,CAID__c,Opportunity__r.AmDocs_ServiceID__c from Smartbox__c 
                                           where CAID__c in :receiverNumbers and Action__c='Active'];
        system.debug('Mahim-activeEquipList: '+activeEquipList);
        //Milestone: MS-000022 - Mahim - End
        
        Boolean hasOwnDupe=false;
        Boolean hasOtherDupe=false;
        Boolean hasAdded=false;
        
        for(Smartbox__c anE:equipList)
        {
            //Milestone: MS-001258 - Mahim - Start
            //EquipData aData=populateEquipData(anE.Id,anE.Equip_Lookup_info__c,
            //anE.Name,anE.Is_active_elsewhere__c,anE.Where_it_s_active_elsewhere__c);
            EquipData aData=populateEquipData(anE.Id,anE.Equip_Lookup_info__c,
                                              anE.CAID__c,anE.Is_active_elsewhere__c,anE.Where_it_s_active_elsewhere__c); 
            //Milestone: MS-001258 - Mahim - End
            
            aData.isSB=true;
            
            if(anE.Case__c!=null){aData.isOther=true;hasOtherDupe=true;}
            if(anE.Case__c!=null)aData.caseDetails=anE.Case__c;
            
            if(anE.Is_active_elsewhere__c && anE.Case__c==null)hasOwnDupe=true;
            if(!anE.Is_active_elsewhere__c && anE.Action__c=='Active'){hasOwnDupe=true;aData.isActiveElsewhere=true;}
            if(!anE.Is_active_elsewhere__c)hasAdded=true;
            
            //Milestone: MS-000022 - Mahim - Start
            for(Smartbox__c SB: activeEquipList){if(SB.CAID__c == anE.CAID__c){aData.ServiceID = SB.Opportunity__r.AmDocs_ServiceID__c;}}
            //Milestone: MS-000022 - Mahim - End
            
            equipDataList.add(aData);
        }
        
        if(equipDataList.size()>0)
        {
            equipDataList[0].hasOwnActiveElsewhere=hasOwnDupe;
            equipDataList[0].hasOtherActiveElsewhere=hasOtherDupe;
            equipDataList[0].hasAddedEquip=hasAdded;
        }
        
        return equipDataList;
    }
    @AuraEnabled
    public static EquipData populateEquipData(String equipId,String lookupInfo
                                              ,String receiverNumber,boolean isActive,String oppId) 
    {
        EquipData aData=new EquipData();
        
        aData.equipId=equipId;
        aData.equipName=lookupInfo;
        aData.receiverNumber=receiverNumber;
        aData.isActiveElsewhere=isActive;
        aData.activeOppId=oppId;
        aData.isTE=false;
        aData.isSB=false;
        aData.isHE=false;
        
        return aData;
    }
    
    @AuraEnabled
    public static DisconnectResponse proceedDisconnect(String strEData)
    {
        DisconnectResponse resp=new DisconnectResponse();
        EquipData eData=(EquipData)JSON.deserialize(strEData, EquipData.class);
        SYSTEM.debug('EDATA'+eData);
        if(eData.isTE==true)
        {
            resp=disconnectTE(eData);
        }
        if(eData.isHE== true || eData.isSB==true){resp=disconnectHESB(eData); }
        return resp;
    }
    @AuraEnabled
    public static DisconnectResponse disconnectTE(EquipData eData) 
    {
        DisconnectResponse resp=new DisconnectResponse();
        SYSTEM.debug('EDATA'+eData);
        List<Tenant_Equipment__c> teRecs=[select id, Amdocs_Tenant_ID__c, Smart_Card__c, Name, Unit__c, Location__c, Action__c, Opportunity__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c
                                          from Tenant_Equipment__c where Name =:eData.receiverNumber and Opportunity__c=:eData.activeOppId and Action__c='Active'];
        System.debug('Dupe Opp Id:'+eData.activeOppId+', Receiver Number='+eData.receiverNumber);
        System.debug('teRecs:::'+teRecs);
        
        if(teRecs!=null && teRecs.size()>0){AmDocs_CalloutClass_BulkDIGITALRemove2.processAmDocsMakeCalloutBulkDIGITALRemove2(teRecs);Tenant_Equipment__c teRec=[select Id,Name,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c from Tenant_Equipment__c where Id=:teRecs[0].Id];if(teRec.Action__c=='Removed'){resp.apiStatus='SUCCESS'; resp.apiDesc='Equipment '+teRec.Name+' disconnected successfully.';}else{resp.apiStatus=teRec.AmDocs_Transaction_Code__c;resp.apiDesc=teRec.AmDocs_Transaction_Description__c;}
        }
        
        //Milestone: MS-001257 - Mahim - Start ---------------------------------------------------Not Used Anymore
        //If the Equipment is active as Smartbox or HeadEnd Equipment
        
        List<Equipment__c> heRecords=new List<Equipment__c>();
        List<Smartbox__c> sbRecords=new List<Smartbox__c>();
        List<String> receiverNumbers=new List<String>();
        String recName='';
        String updatedAction='';
        String code='';
        String message='';
        
        
        heRecords=[Select Id,Action__c from Equipment__c where Name =:eData.receiverNumber and Opportunity__c=:eData.activeOppId and Action__c='Active'];
        sbRecords=[Select Id,Action__c from Smartbox__c where Name =:eData.receiverNumber and Opportunity__c=:eData.activeOppId and Action__c='Active'];
        system.debug('heRecords- '+heRecords);
        system.debug('sbRecords- '+sbRecords);
        receiverNumbers.add(eData.receiverNumber);        
        
        if((heRecords!=null && heRecords.size()>0) || (sbRecords!=null && sbRecords.size()>0)){AmDocs_CalloutClass_BulkUpdatePurge.AmDocsMakeCalloutBulkUpdateAll(eData.activeOppId,receiverNumbers);if(eData.isHE){Equipment__c teRec=[select Id,Name,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c from Equipment__c where Id=:heRecords[0].Id];updatedAction=teRec.Action__c;recName=teRec.Name;code=teRec.AmDocs_Transaction_Code__c;message=teRec.AmDocs_Transaction_Description__c;}
            
            if(eData.isSB){ Smartbox__c teRec=[select Id,Name,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c from Smartbox__c where Id=:sbRecords[0].Id]; updatedAction=teRec.Action__c;recName=teRec.Name;code=teRec.AmDocs_Transaction_Code__c;message=teRec.AmDocs_Transaction_Description__c;}
            
            if(updatedAction=='Removed'){resp.apiStatus='SUCCESS';resp.apiDesc='Equipment '+recName+' disconnected successfully.';}else{Opportunity opp=[Select Id, API_Status__c,AmDocs_Transaction_Description__c from Opportunity where id=:eData.activeOppId]; resp.apiStatus=opp.API_Status__c; resp.apiDesc=opp.AmDocs_Transaction_Description__c;
            }
        }
        
        //Milestone: MS-001257 - Mahim - End ---------------------------------------------------
        
        return resp;
    }
    @AuraEnabled
    public static DisconnectResponse disconnectHESB(EquipData eData)
    {
        DisconnectResponse resp=new DisconnectResponse();
        List<Equipment__c> heRecords=new List<Equipment__c>();
        List<Smartbox__c> sbRecords=new List<Smartbox__c>();
        
        List<String> receiverNumbers=new List<String>();
        
        receiverNumbers.add(eData.receiverNumber);
        
        String recName='';
        String updatedAction='';
        String code='';
        String message='';
        system.debug('eData - '+ eData);
        if(eData.isHE)heRecords=[Select Id,Action__c from Equipment__c where Name =:eData.receiverNumber and Opportunity__c=:eData.activeOppId and Action__c='Active'];
        //Milestone: MS-001258 - Mahim - Start ------------------------Not Used Anymore
        //if(eData.isSB)sbRecords=[Select Id,Action__c from Smartbox__c where Name =:eData.receiverNumber and Opportunity__c=:eData.activeOppId and Action__c='Active'];
        if(eData.isSB)sbRecords=[Select Id,Action__c from Smartbox__c where CAID__c =:eData.receiverNumber and Opportunity__c=:eData.activeOppId and Action__c='Active'];
        //Milestone: MS-001258 - Mahim - End
        system.debug('sbRecords - '+ sbRecords);
        
        if(!Test.isRunningTest()){AmDocs_CalloutClass_BulkUpdatePurge.AmDocsMakeCalloutBulkUpdateAll(eData.activeOppId,receiverNumbers);}
        
        if(eData.isHE){Equipment__c teRec=[select Id,Name,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c from Equipment__c where Id=:heRecords[0].Id];updatedAction=teRec.Action__c;recName=teRec.Name;code=teRec.AmDocs_Transaction_Code__c;message=teRec.AmDocs_Transaction_Description__c;}
        
        if(eData.isSB){Smartbox__c teRec=[select Id,Name,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c from Smartbox__c where Id=:sbRecords[0].Id];updatedAction=teRec.Action__c;recName=teRec.Name;code=teRec.AmDocs_Transaction_Code__c;message=teRec.AmDocs_Transaction_Description__c;}
        
        if(updatedAction=='Removed'){resp.apiStatus='SUCCESS';resp.apiDesc='Equipment '+recName+' disconnected successfully.';}
        
        else{Opportunity opp=[Select Id, API_Status__c,AmDocs_Transaction_Description__c from Opportunity where id=:eData.activeOppId];resp.apiStatus=opp.API_Status__c;resp.apiDesc=opp.AmDocs_Transaction_Description__c;        }
        
        return resp;
    }
    @AuraEnabled
    public static DisconnectResponse loadRecord(String strEData)
    {
        DisconnectResponse resp=new DisconnectResponse();
        
        EquipData eData=(EquipData)JSON.deserialize(strEData, EquipData.class);
        List<Tenant_Equipment__c> teRecs=[select Id,Name,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c
                                          from Tenant_Equipment__c where Name=:eData.receiverNumber and Opportunity__c=:eData.activeOppId and Action__c='Active'];
        
        if(teRecs!=null && teRecs.size()>0){Tenant_Equipment__c teRec=teRecs[0];resp.equipId=teRec.Id; if(teRec.Action__c=='Remove'){resp.apiStatus='SUCCESS';resp.apiDesc='Equipment '+teRec.Name+' disconnected successfully.';} else {resp.apiStatus=teRec.AmDocs_Transaction_Code__c;resp.apiDesc=teRec.AmDocs_Transaction_Description__c;}
        }
        return resp;
    }
    public Class DisconnectResponse
    {
        @AuraEnabled
        public String equipId{get;set;}
        
        @AuraEnabled
        public String apiDesc{get;set;}
        
        @AuraEnabled
        public String apiStatus{get;set;}
    }
    public class EquipData
    {
        @AuraEnabled
        public String equipId{get;set;}
        
        @AuraEnabled
        public String receiverNumber{get;set;}
        
        @AuraEnabled
        public String activeOppId{get;set;}
        
        @AuraEnabled
        public String equipName{get;set;}
        
        @AuraEnabled
        public boolean isActiveElsewhere{get;set;}
        
        @AuraEnabled
        public boolean isOther{get;set;}
        
        @AuraEnabled
        public String caseDetails{get;set;}
        
        @AuraEnabled
        public boolean hasOwnActiveElsewhere{get;set;}
        
        @AuraEnabled
        public boolean hasOtherActiveElsewhere{get;set;}
        
        @AuraEnabled
        public boolean hasAddedEquip{get;set;}
        
        @AuraEnabled
        public boolean disconnect{get;set;}
        
        @AuraEnabled
        public boolean isTE{get;set;}
        
        @AuraEnabled
        public boolean isHE{get;set;}
        
        @AuraEnabled
        public boolean isSB{get;set;}
        
        //Milestone: MS-000022 - Mahim - Start
        @AuraEnabled
        public string TenantID{get;set;}
        
        @AuraEnabled
        public string action{get;set;}
        
        @AuraEnabled
        public string ServiceID{get;set;}
        //Milestone: MS-000022 - Mahim - End
    }
    
    //Milestone: MS-000022 - Mahim - Start
    @AuraEnabled
    public static void setActionforTE(string lstTEData)
    {
        system.debug('lstTEData - '+lstTEData);
        
        DisconnectResponse resp=new DisconnectResponse();
        List<EquipData> eData=(List<EquipData>)JSON.deserialize(lstTEData, List<EquipData>.class);
        List<Tenant_Equipment__c> updateTEAction = new List<Tenant_Equipment__c>();
        List<Tenant_Equipment__c> updateTEActionWithTAcc = new List<Tenant_Equipment__c>();
        List<Id> lstTenantAccountId = new List<Id>();
        List<Tenant_Account__c> updateTAAction = new List<Tenant_Account__c>();
        List<String> lstReceiverNumer = new List<String>();
        List<String> tempTenantID = new List<String>();
        Set<String> uniqueTenantID = new Set<String>();
        Integer countReceiver;
        list<Tenant_Equipment__c> TEDataWithTAcc = new List<Tenant_Equipment__c>();
        list<Tenant_Equipment__c> TEDataWithoutTAcc = new List<Tenant_Equipment__c>();
        
        for(EquipData ED: eData){
            lstReceiverNumer.add(ED.receiverNumber);
        }
        list<Tenant_Equipment__c> TEData = [select Id, Name, Amdocs_Tenant_ID__c, Action__c,Tenant_Account__c from Tenant_Equipment__c 
                                            where Name IN: lstReceiverNumer AND Action__c='Active' AND Amdocs_Tenant_ID__c != null]; // and Tenant_Account__c = null
        system.debug('TEData - '+TEData);
        
        for(Tenant_Equipment__c tE: TEData){
            if(tE.Tenant_Account__c == null)
                TEDataWithoutTAcc.add(tE);
            else
                TEDataWithTAcc.add(tE);
        }
        system.debug('TEDataWithoutTAcc - '+TEDataWithoutTAcc);
        system.debug('TEDataWithTAcc - '+TEDataWithTAcc);
        
        for(Tenant_Equipment__c TE: TEDataWithTAcc){
            TE.Action__c = 'DupeDisconnect';
            updateTEActionWithTAcc.add(TE);
            lstTenantAccountId.add(TE.Tenant_Account__c);
        }
        system.debug('lstTenantAccountId - '+lstTenantAccountId);
        
        List<Tenant_Account__c> lstTAData = [select Id, Action__c from Tenant_Account__c where Id in : lstTenantAccountId];
        for(Tenant_Account__c TA: lstTAData){
            TA.Action__c = 'DupeDisconnect';
            updateTAAction.add(TA);
        }
        system.debug('updateTAAction - '+updateTAAction);
        
        if(updateTEActionWithTAcc.size()>0 && updateTAAction.size()>0){
            try {
                Update updateTEActionWithTAcc;
                update updateTAAction;
            } catch(DmlException e) {
                System.debug('The following exception has occurred: ' + e.getMessage());
            }
        }
        
        for(Tenant_Equipment__c ED: TEDataWithoutTAcc){
            tempTenantID.add(ED.Amdocs_Tenant_ID__c);
        }
        uniqueTenantID.addAll(tempTenantID);      
        system.debug('uniqueTenantID - '+uniqueTenantID);
        
        list<AggregateResult> groupedTEData = [select Amdocs_Tenant_ID__c, count(Name) from Tenant_Equipment__c 
                                               where Action__c='Active' and Tenant_Account__c = null and Amdocs_Tenant_ID__c IN: uniqueTenantID Group By Amdocs_Tenant_ID__c]; 
        system.debug('groupedTEData - '+groupedTEData);
        
        Map<String,Integer> TECount = new Map<String,Integer>();
        for(Tenant_Equipment__c key : TEDataWithoutTAcc)
        {
            if(!TECount.containsKey(key.Amdocs_Tenant_ID__c)){
                TECount.put(key.Amdocs_Tenant_ID__c,0);
            }
            Integer currentInt=TECount.get(key.Amdocs_Tenant_ID__c)+1;
            TECount.put(key.Amdocs_Tenant_ID__c,currentInt);
        }
        system.debug('TECount - '+TECount);
        
        for(Tenant_Equipment__c eD : TEDataWithoutTAcc){
            for (AggregateResult ar : groupedTEData)  {
                if(eD.Amdocs_Tenant_ID__c == ar.get('Amdocs_Tenant_ID__c')){
                    System.debug('Amdocs_Tenant_ID__c- ' + ar.get('Amdocs_Tenant_ID__c'));
                    System.debug('Count- ' + ar.get('expr0'));
                    if(TECount.get(eD.Amdocs_Tenant_ID__c) == ar.get('expr0')){
                        eD.Action__c = 'DupeDisconnect';
                        updateTEAction.add(eD);
                    }
                    else{
                        eD.Action__c = 'DupeREMOVE';
                        updateTEAction.add(eD);
                    }
                }
            }
        }
        system.debug('updateTEAction1 - '+updateTEAction);
        if(updateTEAction.size()>0){
            try {
                Update updateTEAction;
            } catch(DmlException e) {
                System.debug('The following exception has occurred: ' + e.getMessage());
            }
        }
        //checking if the receiver is active in HeadEnd or Smartbox equipment
        else{ 
            List<Equipment__c> activeHEEquipList=[select Id,Name,Action__c,Opportunity__r.AmDocs_ServiceID__c from Equipment__c 
                                                  where Name in :lstReceiverNumer and Action__c='Active'];
            List<Smartbox__c> activeSBEquipList=[select Id,CAID__c,Action__c,Opportunity__r.AmDocs_ServiceID__c from Smartbox__c 
                                                 where CAID__c in :lstReceiverNumer and Action__c='Active'];
            if(activeHEEquipList.size()>0 || activeSBEquipList.size()>0){
                setActionforHESB(lstTEData);
            }
        }
        system.debug('updateTEAction2 - '+updateTEAction);
        
        /*list<Id> updatedTEId = new list<Id>();
list<Tenant_Equipment__c> updatedTEData = new list<Tenant_Equipment__c>();
for(Tenant_Equipment__c TE: updateTEAction){
updatedTEId.add(TE.Id);
}
system.debug('updatedTEId - '+updatedTEId);
if(updatedTEId.size()>0)
updatedTEData = [select Id, Name, Amdocs_Tenant_ID__c, Action__c from Tenant_Equipment__c where Id IN: updatedTEId];
system.debug('updatedTEData - '+updatedTEData);
if(updatedTEData.size()>0)
return UpdatedTEData;
else
return null;*/
    }
    
    @AuraEnabled
    public static DisconnectResponse disconnectTENew(String strTenantId, String ReceiverforHESB) 
    {
        DisconnectResponse resp=new DisconnectResponse();
        String APIAction;
        list<Tenant_Equipment__c> updatedTEData = new list<Tenant_Equipment__c>();
        list<Tenant_Account__c> updatedTAData = new list<Tenant_Account__c>();
        set<String> receiverNumbers = new set<String>();
        list<String> finalReceiverNumbers = new list<String>();
        list<Id> lstTAId = new list<Id>();
        list<String> receiversForActiveElseWhereUpdate = new list<String>();
        list<Tenant_Equipment__c> teForActiveElseWhereUpdate = new list<Tenant_Equipment__c>();
        list<Tenant_Equipment__c> teWithActiveElseWhereTrue = new list<Tenant_Equipment__c>();
        string strTenantAccountID;
        String returnStatus;
        
        system.debug('ReceiverforHESB - '+ReceiverforHESB);
        updatedTEData = [select Id, Name, Amdocs_Tenant_ID__c, Action__c,Tenant_Account__c,Tenant_Account__r.Action__c, AmDocs_Transaction_Code__c,AmDocs_Transaction_Description__c
                         from Tenant_Equipment__c where Amdocs_Tenant_ID__c =: strTenantId and 
                         (Action__c='DupeDisconnect' or Action__c='DupeREMOVE' or Tenant_Account__r.Action__c='DupeDisconnect')];
        system.debug('updatedTEData - '+updatedTEData);
        /*for(Tenant_Equipment__c TE :updatedTEData){
        if(TE.Tenant_Account__c != null)
        lstTAId.add(TE.Tenant_Account__c);
        }
        updatedTAData = [select Id, Action__c from Tenant_Account__c where Id in: lstTAId];*/
        if(updatedTEData.size()>0){
            for(Tenant_Equipment__c TE :updatedTEData){
                if(TE.Tenant_Account__c != null){
                    strTenantAccountID = TE.Tenant_Account__c;
                    if(TE.Action__c == 'DupeDisconnect' && TE.Tenant_Account__r.Action__c == 'DupeDisconnect'){
                        receiverNumbers.add(TE.name);
                        APIAction = 'TEWithTA-Disconnect';
                    }
                }
                else if(TE.Action__c == 'DupeDisconnect')
                    APIAction = 'Disconnect';
                else if(TE.Action__c == 'DupeREMOVE')
                    APIAction = 'Remove';
                else{}
            }
            system.debug('APIAction - '+APIAction);
            
            if(APIAction == 'TEWithTA-Disconnect')
                returnStatus = AmDocs_CalloutClass_TNAGMeISActvElsWhrDC.AmDocsMakeCalloutTNAMuteDC(strTenantAccountID);
            if(APIAction == 'Disconnect')
                returnStatus = AmDocs_CalloutClass_TNEGuideMeDupeDC.TellAmdocsToDISCONNECT(strTenantId);
            if(APIAction == 'Remove')
                returnStatus = AmDocs_Callout_TEQGMeIsActivElsWhrREMOVE.TellAmdocs2REMOVETEQOnServiceID(strTenantId);

            String equipmentNumbers = ' ';
            List<Tenant_Equipment__c> teRec=[select Id,Name,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c,
                                             Tenant_account__c,Tenant_account__r.action__c, Tenant_account__r.AmDocs_Transaction_Description__c,Tenant_account__r.AmDocs_Transaction_Code__c
                                             from Tenant_Equipment__c where Amdocs_Tenant_ID__c=:strTenantId];
            /*List<Id> lstTAID2 = new List<Id>();
            List<Tenant_Account__c> taRec = new List<Tenant_Account__c>();
            if(teRec.size()>0){
            for(Tenant_Equipment__c TE: teRec){
            lstTAID2.add(TE.Tenant_Account__c);
            }
            }
            if(lstTAID2.size()>0){
            taRec=[select Id, action__c from Tenant_Account__c where Id in :lstTAID2];
            }*/
            
            system.debug('teRec - '+teRec);
            system.debug('receiverNumbers - '+receiverNumbers);
            
            if(teRec.size()>0){
                if(returnStatus == 'Success'){
                    if(APIAction == 'TEWithTA-Disconnect'){
                        finalReceiverNumbers.addAll(receiverNumbers);
                        for(Tenant_Equipment__c TE: teRec){
                            if(finalReceiverNumbers[0] == TE.Name){
                                //equipmentNumbers = equipmentNumbers + ' ' + TE.Name;
                                if(TE.Action__c=='Disconnected' && TE.Tenant_account__r.action__c == 'Disconnected'){
                                    resp.apiStatus='SUCCESS';
                                    resp.apiDesc='Equipment '+receiverNumbers+' disconnected successfully.';
                                    receiversForActiveElseWhereUpdate.add(TE.Name);
                                }
                                else{
                                    resp.apiStatus=TE.Tenant_account__r.AmDocs_Transaction_Code__c;
                                    resp.apiDesc=TE.Tenant_account__r.AmDocs_Transaction_Description__c;
                                }
                            }
                        }
                    }
                    else{
                        for(Tenant_Equipment__c TE: teRec){
                            if(TE.Action__c=='DupeDisconnect Successful'){
                                equipmentNumbers = equipmentNumbers + ' ' + TE.Name;
                                resp.apiStatus='SUCCESS';
                                resp.apiDesc='Equipment '+equipmentNumbers+' disconnected successfully.';
                                receiversForActiveElseWhereUpdate.add(TE.Name);
                            }
                            else if(TE.Action__c=='Removed' ){
                                equipmentNumbers = equipmentNumbers + ' ' + TE.Name;
                                resp.apiStatus='SUCCESS';
                                resp.apiDesc='Equipment '+equipmentNumbers+' removed successfully.';
                                receiversForActiveElseWhereUpdate.add(TE.Name);
                            }
                        }
                        if(resp.apiStatus!='SUCCESS'){
                            for(Tenant_Equipment__c TE: teRec){
                                if(TE.AmDocs_Transaction_Code__c!= null && TE.AmDocs_Transaction_Code__c != ''){
                                    resp.apiStatus=TE.AmDocs_Transaction_Code__c;
                                    resp.apiDesc=TE.AmDocs_Transaction_Description__c;
                                }
                            }
                        }
                    }
                    //Reverting the action back to Active if API call did not happen or some error occurred
                    list<Tenant_Equipment__c> RevertTEAction = new list<Tenant_Equipment__c>();
                    list<Tenant_Account__c> RevertTAAction = new list<Tenant_Account__c>();
                    String checkAction = 'DupeDisconnect';
                    
		            if(APIAction == 'Remove')
                        checkAction = 'DupeREMOVE';
                    
                    list<Tenant_Equipment__c> CheckTEAction = [select Id, Action__c,Tenant_Account__c from Tenant_Equipment__c
                                                               where Amdocs_Tenant_ID__c =: strTenantId and Action__c=: checkAction];
                    for(Tenant_Equipment__c TE: CheckTEAction){
                        TE.Action__c = 'Active';
                        RevertTEAction.add(TE);
                    }
                    if(RevertTEAction.size()>0)
                        Update RevertTEAction;
                    
                    if(CheckTEAction.size()>0){
                        list<Tenant_Account__c> CheckTAAction = [select Id, Action__c from Tenant_Account__c
                                                                 where Id =: CheckTEAction[0].Tenant_Account__c and Action__c='DupeDisconnect'];
                        for(Tenant_Account__c TA: CheckTAAction){
                            TA.Action__c = 'Active';
                            RevertTAAction.add(TA);
                        }
                        if(RevertTAAction.size()>0)
                            Update RevertTAAction;
                    }
                } 
                else{
                    resp.apiStatus='Error';
                    resp.apiDesc=returnStatus;
                    
                    //Reverting the action back to Active if API call did not happen or some error occurred
                    list<Tenant_Equipment__c> RevertTEAction = new list<Tenant_Equipment__c>();
                    list<Tenant_Account__c> RevertTAAction = new list<Tenant_Account__c>();
                    
                    list<Tenant_Equipment__c> CheckTEAction = [select Id, Action__c,Tenant_Account__c from Tenant_Equipment__c
                                                               where Amdocs_Tenant_ID__c =: strTenantId and (Action__c='DupeDisconnect' or Action__c='DupeREMOVE')];
                    for(Tenant_Equipment__c TE: CheckTEAction){
                        TE.Action__c = 'Active';
                        RevertTEAction.add(TE);
                    }
                    if(RevertTEAction.size()>0)
                        Update RevertTEAction;
                    
                    if(CheckTEAction.size()>0){
                        list<Tenant_Account__c> CheckTAAction = [select Id, Action__c from Tenant_Account__c
                                                                 where Id =: CheckTEAction[0].Tenant_Account__c and Action__c='DupeDisconnect'];
                        for(Tenant_Account__c TA: CheckTAAction){
                            TA.Action__c = 'Active';
                            RevertTAAction.add(TA);
                        }
                        if(RevertTAAction.size()>0)
                            Update RevertTAAction;
                    }
                }
            }
            system.debug('resp - '+resp);
            //Milestone #MS-001326 - Mahim - Start
            //Update the ActiveElseWhere field of new equipment to false if the disconnect/remove is successful
            if(receiversForActiveElseWhereUpdate.size()>0){
                teWithActiveElseWhereTrue = [Select Id,Is_active_elsewhere__c,Where_it_s_active_elsewhere__c From Tenant_Equipment__c 
							Where name in: receiversForActiveElseWhereUpdate And Is_active_elsewhere__c = true And Action__c='Add'];
                for(Tenant_Equipment__c TE: teWithActiveElseWhereTrue){
                    TE.Is_active_elsewhere__c = false;
                    TE.Where_it_s_active_elsewhere__c = null;
                    teForActiveElseWhereUpdate.add(TE);
                }
                if(teForActiveElseWhereUpdate.size()>0){
                    Update teForActiveElseWhereUpdate;
                }
            }
            //Milestone #MS-001326 - End
        }
        
        if(updatedTEData.size() == 0){
            system.debug('isFirstTime1 -'+isFirstTime);
            if(isFirstTime == true){
                String ServiceID;
                isFirstTime = false;
                
                List<Equipment__c> activeHEEquipList=[select Id,Opportunity__r.AmDocs_ServiceID__c from Equipment__c 
                                                      where Name = :ReceiverforHESB and Action__c='DupeREMOVE'];
                system.debug('activeHEEquipList -'+activeHEEquipList);
                List<Smartbox__c> activeSBEquipList=[select Id,Opportunity__r.AmDocs_ServiceID__c from Smartbox__c 
                                                     where CAID__c = :ReceiverforHESB and Action__c='DupeREMOVE'];
                
                if(activeHEEquipList.size()>0)
                    ServiceID = activeHEEquipList[0].Opportunity__r.AmDocs_ServiceID__c;
                if(activeSBEquipList.size()>0)
                    ServiceID = activeSBEquipList[0].Opportunity__r.AmDocs_ServiceID__c;
                
                resp = disconnectHESBNew(ServiceID, null);
            }
        }
        return resp;
    }
    
    @AuraEnabled
    public static void setActionforHESB(string lstHESBData)
    {
        DisconnectResponse resp=new DisconnectResponse();
        List<EquipData> eData=(List<EquipData>)JSON.deserialize(lstHESBData, List<EquipData>.class);
        List<String> lstHEReceiverNumber = new List<String>();
        List<String> lstSBReceiverNumber = new List<String>();
        List<String> lstReceiverNumber = new List<String>();	//creating this list to check if the receiver number is active in Tenant Equipment
        List<Equipment__c> updateHEAction = new List<Equipment__c>();
        List<Smartbox__c> updateSBAction = new List<Smartbox__c>();
        
        system.debug('lstHESBData - '+lstHESBData);
        
        for(EquipData ED: eData){
            lstReceiverNumber.add(ED.receiverNumber);
            /*if(ED.isHE)
            lstHEReceiverNumber.add(ED.receiverNumber);
            else
            lstSBReceiverNumber.add(ED.receiverNumber);*/
        }
        List<Equipment__c> activeHEEquipList=[select Id,Name,Action__c,Opportunity__r.AmDocs_ServiceID__c from Equipment__c 
                                              where Name in :lstReceiverNumber and Action__c='Active'];
        
        List<Smartbox__c> activeSBEquipList=[select Id,CAID__c,Action__c,Opportunity__r.AmDocs_ServiceID__c from Smartbox__c 
                                             where CAID__c in :lstReceiverNumber and Action__c='Active'];
        
        if(activeSBEquipList.size()>0 || activeHEEquipList.size()>0){
            
            if(activeHEEquipList.size()>0){
                for(Equipment__c HE: activeHEEquipList){
                    HE.Action__c = 'DupeREMOVE';
                    updateHEAction.add(HE);
                }
            }
            if(updateHEAction.size()>0){
                try {
                    Update updateHEAction;
                } catch(DmlException e) {
                    System.debug('The following exception has occurred: ' + e.getMessage());
                }
            }
            
            if(activeSBEquipList.size()>0){
                for(Smartbox__c SB: activeSBEquipList){
                    SB.Action__c = 'DupeREMOVE';
                    updateSBAction.add(SB);
                }
            }
            if(updateSBAction.size()>0){
                try {
                    Update updateSBAction;
                } catch(DmlException e) {
                    System.debug('The following exception has occurred: ' + e.getMessage());
                }
            }
        }
        //checking if the receiver is active in Tenant equipment
        else{ 
            list<Tenant_Equipment__c> TEData = [select Id, Name, Amdocs_Tenant_ID__c, Action__c,Tenant_Account__c from Tenant_Equipment__c 
                                                where Name IN: lstReceiverNumber AND Action__c='Active' AND Amdocs_Tenant_ID__c != null];
            if(TEData.size()>0){
                setActionforTE(lstHESBData);
            }
        }
    }
    
    @AuraEnabled
    public static DisconnectResponse disconnectHESBNew(String strServiceId, String ReceiverforTE) 
    {
        DisconnectResponse resp=new DisconnectResponse();
        list<Equipment__c> updatedHEData = new list<Equipment__c>();
        list<Smartbox__c > updatedSBData = new list<Smartbox__c >();
        list<Id> updatedHEId = new list<Id>();
        list<Id > updatedSBId = new list<Id >();
        String recName=''; String updatedAction=''; String code=''; 
        String message=''; String OppId='';
        list<Equipment__c> RevertHEAction = new list<Equipment__c>();
        list<Smartbox__c> RevertSBAction = new list<Smartbox__c>();
        String returnStatus;
        list<String> lstAllReceivers = new list<String>();
        list<String> receiversForActiveElseWhereUpdate = new list<String>();
        list<Equipment__c> heWithActiveElseWhereTrue = new list<Equipment__c>();
        list<Equipment__c> heForActiveElseWhereUpdate = new list<Equipment__c>();
        //list<String> receiversForActiveElseWhereUpdate = new list<String>();
        list<Smartbox__c> sbWithActiveElseWhereTrue = new list<Smartbox__c>();
        list<Smartbox__c> sbForActiveElseWhereUpdate = new list<Smartbox__c>();
        
        
        system.debug('strServiceId - '+strServiceId);
        
        updatedHEData = [select Id, Name, Opportunity__c from Equipment__c where Opportunity__r.AmDocs_ServiceID__c =: strServiceId 
                         and Action__c='DupeREMOVE'];
        
        updatedSBData = [select Id, Name, Opportunity__c from Smartbox__c where Opportunity__r.AmDocs_ServiceID__c =: strServiceId 
                         and Action__c='DupeREMOVE'];
        
        try{
            
            if(updatedHEData.size()>0 || updatedSBData.size()>0)
                returnStatus = AmDocs_CalloutClass_BulkUpdateGMDupeRmv.TellAmdocstoRemoveThisEquipmentFromServiceID(strServiceId);
            
            if((updatedHEData.size()>0 || updatedSBData.size()>0) && returnStatus == 'Success' ){    
                if(updatedHEData.size()>0){
                    for(Equipment__c HE:updatedHEData){
                        updatedHEId.add(HE.Id);
                    }
                    
                    List<Equipment__c> teRec=[select Id,Name,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c,
                                              Opportunity__c from Equipment__c where Id in :updatedHEId];
                    for(Equipment__c HE: teRec){
                        recName= recName +' '+ HE.Name;
                        if(teRec[0].Action__c=='Removed'){
                            receiversForActiveElseWhereUpdate.add(HE.Name);
                        }
                    }
                    OppId = teRec[0].Opportunity__c;
                    updatedAction=teRec[0].Action__c;
                    code=teRec[0].AmDocs_Transaction_Code__c;
                    message=teRec[0].AmDocs_Transaction_Description__c;
                }
                
                if(updatedSBData.size()>0){
                    for(Smartbox__c SB:updatedSBData){
                        updatedSBId.add(SB.Id);
                    }
                    List<Smartbox__c> teRec=[select Id,Name,CAID__c,Action__c,AmDocs_Transaction_Description__c,AmDocs_Transaction_Code__c,
                                             Opportunity__c from Smartbox__c where Id in :updatedSBId];
                    for(Smartbox__c SB: teRec){
                        recName= recName +' '+ SB.CAID__c;
                        if(teRec[0].Action__c=='Removed'){
                            receiversForActiveElseWhereUpdate.add(SB.CAID__c);
                        }
                    }
                    OppId = teRec[0].Opportunity__c;
                    updatedAction=teRec[0].Action__c;
                    code=teRec[0].AmDocs_Transaction_Code__c;
                    message=teRec[0].AmDocs_Transaction_Description__c;
                }
                
                
                if(updatedAction=='Removed'){
                    resp.apiStatus='SUCCESS';
                    resp.apiDesc='Equipment '+recName+' disconnected successfully.';
                }
                else{
                    Opportunity opp=[Select Id, API_Status__c,AmDocs_Transaction_Description__c from Opportunity where id=:OppId];
                    resp.apiStatus=opp.API_Status__c;
                    resp.apiDesc=opp.AmDocs_Transaction_Description__c;
                }    
            }
            else if((updatedHEData.size()>0 || updatedSBData.size()>0) && returnStatus != 'Success' ){
                resp.apiStatus='Error';
                resp.apiDesc=returnStatus;
                
                //Reverting the Action back to Active
                List<Equipment__c > checkHEData = [select Id, Action__c from Equipment__c where Opportunity__r.AmDocs_ServiceID__c =: strServiceId 
                                                   and Action__c='DupeREMOVE'];
                for(Equipment__c HE: checkHEData){
                    HE.Action__c = 'Active';
                    RevertHEAction.add(HE);
                }
                if(RevertHEAction.size()>0)
                    Update RevertHEAction;
                
                List<Smartbox__c> checkSBData = [select Id, Action__c from Smartbox__c where Opportunity__r.AmDocs_ServiceID__c =: strServiceId 
                                                 and Action__c='DupeREMOVE'];
                for(Smartbox__c SB: checkSBData){
                    SB.Action__c = 'Active';
                    RevertSBAction.add(SB);
                }
                if(RevertSBAction.size()>0)
                    Update RevertSBAction;
            }
            else{
                resp.apiStatus='Error';
                resp.apiDesc='An unexpected error have occurred. Please contact System Admin';
            }
            
            //Milestone #MS-001326 - Mahim - Start
            //Update the ActiveElseWhere field of new equipment to false if the disconnect/remove is successful
            if(receiversForActiveElseWhereUpdate.size()>0){
                heWithActiveElseWhereTrue = [Select Id,Is_active_elsewhere__c,Where_it_s_active_elsewhere__c From Equipment__c 
                	Where name in: receiversForActiveElseWhereUpdate And Is_active_elsewhere__c = true And Action__c='Add'];
                for(Equipment__c HEq: heWithActiveElseWhereTrue){
                    HEq.Is_active_elsewhere__c = false;
                    HEq.Where_it_s_active_elsewhere__c = null;
                    heForActiveElseWhereUpdate.add(HEq);
                }
                if(heForActiveElseWhereUpdate.size()>0){
                    Update heForActiveElseWhereUpdate;
                }
                
                sbWithActiveElseWhereTrue = [Select Id,Is_active_elsewhere__c,Where_it_s_active_elsewhere__c From Smartbox__c 
                	Where CAID__c in: receiversForActiveElseWhereUpdate And Is_active_elsewhere__c = true And Action__c='Add'];
                for(Smartbox__c SBq: sbWithActiveElseWhereTrue){
                    SBq.Is_active_elsewhere__c = false;
                    SBq.Where_it_s_active_elsewhere__c = null;
                    sbForActiveElseWhereUpdate.add(SBq);
                }
                if(sbForActiveElseWhereUpdate.size()>0){
                    Update sbForActiveElseWhereUpdate;
                }
            }
            //Milestone #MS-001326 - End
            
            //Checking if the Receiver is active on Tenant Equipment
            if(updatedHEData.size() == 0 && updatedSBData.size() == 0){
                system.debug('isFirstTime2 -'+isFirstTime);
                if(isFirstTime == true){
                    String TenantID;
                    isFirstTime = false;
                    
                    list<Tenant_Equipment__c> TEData = [select Id, Amdocs_Tenant_ID__c from Tenant_Equipment__c 
                                                        where Name =: ReceiverforTE AND Amdocs_Tenant_ID__c != null AND
                                                        (Action__c='DupeDisconnect' or Action__c='DupeREMOVE' or Tenant_Account__r.Action__c='DupeDisconnect')];
                    if(TEData.size()>0)
                        TenantID = TEData[0].Amdocs_Tenant_ID__c;
                    
                    resp = disconnectTENew(TenantID,null);
                }
            }
        }
        catch(Exception e) {
            System.debug('The following exception has occurred: ' + e.getMessage());
        }
        return resp;
    }
    //Milestone: MS-000022 - Mahim - End
    
    //MS-001664 - 14May20 - Start
    @AuraEnabled
    public static void deleteAddedEquips(String strEquipIds)
    {
        List<Id> equipIds=new List<Id>();
        List<Tenant_Equipment__c> TEEquipsToDelete = new List<Tenant_Equipment__c>();
        equipIds=(List<Id>)JSON.deserialize(strEquipIds, List<Id>.class);
        system.debug('equipIds-'+equipIds);
        
        if(equipIds.size()>0)
            TEEquipsToDelete = [select Id from Tenant_Equipment__c where Id In :equipIds];
        system.debug('TEEquipsToDelete-'+TEEquipsToDelete);
        if(TEEquipsToDelete.size()>0){
            delete TEEquipsToDelete;
        }
    }
    //MS-001664 - End
}